package gcewing.prospecting;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Hashtable;
import java.util.Map;

import net.minecraft.block.Block;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraftforge.common.Configuration;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.Mod.Init;
import cpw.mods.fml.common.Mod.Instance;
import cpw.mods.fml.common.Mod.PostInit;
import cpw.mods.fml.common.Mod.PreInit;
import cpw.mods.fml.common.SidedProxy;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.event.FMLPostInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.network.NetworkMod;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.common.registry.LanguageRegistry;

@Mod(modid="GregsProspecting", name="GregsProspecting" , version="1.4.2")

@NetworkMod(clientSideRequired=true, serverSideRequired=false, versionBounds = "[1.4,1.5)",
	channels={"gce.prospecting"}, packetHandler = PacketHandler.class)

public class GregsProspecting {
	
	@Instance("GregsProspecting")
	public static GregsProspecting instance;
	
	@SidedProxy(clientSide="gcewing.prospecting.ClientProxy", serverSide="gcewing.prospecting.CommonProxy")
	public static CommonProxy proxy;
	
	public static ItemMiningRadar miningRadar, colorMiningRadar, industrialMiningRadar, industrialMiningRadarCharged;
	public static Item battery, mandrel, batteryCasing, carbonRod,
		electrolytePaste, bowlAppleJuice, carbonFilament, cathodeRayTube, magnetron,
		fibreglassBoard, microwaveHorn, brokenMiningRadar, slimophone, parabolicMicrophone,
		piezoTransducer, quartzWafer, triode, ledBarGraph, redPhosphor, greenPhosphor, bluePhosphor,
		colorCRT, colorMiningRadarCircuit;
	
	static File cfgFile;
	//static Configuration config;
	static OrderedProperties config;
	static Map <Integer, String> idToName = new Hashtable <Integer, String>();
	
	@PreInit
	public void preInit(FMLPreInitializationEvent e) {
		cfgFile = e.getSuggestedConfigurationFile();
	}
	
	@Init
	public void load(FMLInitializationEvent e) {
		loadConfig();
		registerItems();
		addRecipes();
		proxy.registerKeys();		
		proxy.registerRenderers();
	}
	
	@PostInit
	public void postInit(FMLPostInitializationEvent e) {
		saveConfig();
	}
	
//	private void loadConfig()
//	{
//		config = new Configuration(cfgFile);
//		if(config != null)
//			config.load();
//	}

//	void bindKeys() {
//		bindKey(Constants.KEY_DECREASE_RANGE, Keyboard.KEY_LBRACKET, "Reduce Mining Radar Range");
//		bindKey(Constants.KEY_INCREASE_RANGE, Keyboard.KEY_RBRACKET, "Increase Mining Radar Range");
//		bindKey(Constants.KEY_LINEAR_MODE, Keyboard.KEY_L, "Mining Radar Linear Mode");
//		bindKey(Constants.KEY_DISCRIMINATION_MODE, Keyboard.KEY_M, "Mining Radar Discrimination Mode");
////		bindKey(Constants.KEY_SWITCH_MODE, Keyboard.KEY_M, "Switch Mining Radar Mode");
//	}
	
//	void bindKey(String name, int defaultKey, String title) {
//		String cfgName = "key." + name;
//		String bindingName = "key.gcewing." + name;
//		int key = config.getInt(cfgName, defaultKey);
//		proxy.setKeyBinding(bindingName, key);
//		LanguageRegistry.instance().addStringLocalization(bindingName, title);
//	}
	
	void loadConfig() {
		config = new OrderedProperties();
		try {
			config.load(new FileInputStream(cfgFile));
		}
		catch (FileNotFoundException e) {
			System.out.printf("GregsProspecting: No existing config file\n");
		}
		catch (IOException e) {
			System.out.printf("GregsProspecting: Failed to read %s\n%s\n",
				cfgFile.getPath(), e);
		}
		config.extended = false;
	}

//	private void saveConfig()
//	{
//		if(config != null)
//			config.save();
//	}
	
	void saveConfig() {
		try {
			if (config.extended) {
				System.out.printf("GregsProspecting: Writing config file\n");
				config.store(new FileOutputStream(cfgFile),
					"Greg's Prospecting Configuration File");
				//System.out.printf("GregsProspecting: Written config file\n");
			}
		}
		catch (IOException e) {
			System.out.printf("GregsProspecting: Failed to %s\n%s\n",
				cfgFile.getPath(), e);
		}
	}

//	private static int getItemID(int defaultID, String name)
//	{
//		int id;
//		if(config != null)
//		{
//			id = config.getItem(name, defaultID).getInt();
//		}
//		else
//		{
//			id = defaultID;
//		}
//		idToName.put(Integer.valueOf(256+id), name);
//		return id;
//	}
	
	static int getItemID(int defaultID, String name) {
		int id = config.getInt(name, defaultID);
		idToName.put(Integer.valueOf(256 + id), name);
		return id;
	}

	private void registerItems() {
		miningRadar = new ItemMiningRadar(getItemID(3000, "miningRadar"), 17);
		addItem("Mining Rader", miningRadar);
		battery = addItem("Battery", newItemSI(3001, "battery", 6, 0));
		mandrel = addItem("Wooden Mandrel", newItemI(3002, "mandrel", 24));
		mandrel.setContainerItem(mandrel);
		batteryCasing = addItem("Battery Casing", newItemI(3003, "batteryCasing", 1));
		carbonRod = addItem("Carbon Rod", newItemI(3004, "carbonRod", 6));
		electrolytePaste = addItem("Electrolyte Paste", newItemI(3005, "electrolytePaste", 11));
		bowlAppleJuice = addItem("Apple Juice", newItemI(3006, "bowlAppleJuice", 3));
		bowlAppleJuice.setContainerItem(Item.bowlEmpty);
		carbonFilament = addItem("Carbon Filament", newItemI(3007, "carbonFilament", 5));
		cathodeRayTube = addItem("Cathode Ray Tube", newItemI(3008, "cathodeRayTube", 7));
		magnetron = addItem("Magnetron", newItemI(3009, "magnetron", 15));
		fibreglassBoard = addItem("Fibreglass Board", newItemI(3010, "fibreglassBoard", 12));
		microwaveHorn = addItem("Microwave Horn", newItemI(3011, "microwaveHorn", 16));
		brokenMiningRadar = new ItemMiningRadar(getItemID(3012, "brokenMiningRadar"), 4);
		addItem("Broken Mining Radar", brokenMiningRadar);
		slimophone = addItem("Slimophone", new ItemSlimophone(getItemID(3013, "slimophone")));
		parabolicMicrophone = addItem("Parabolic Microphone", newItemI(3014, "parabolicMicrophone", 18));
		piezoTransducer = addItem("Piezo Transducer", newItemI(3015, "piezoTransducer", 19));
		quartzWafer = addItem("Quartz Wafer", newItemI(3016, "quartzWafer", 20));
		triode = addItem("Triode", newItemI(3017, "triode", 23));
		ledBarGraph = addItem("LED Bar Graph", newItemI(3018, "ledBarGraph", 14));
		colorMiningRadar = new ItemMiningRadar(getItemID(3019, "colorMiningRadar"), 9);
		addItem("Colour Mining Radar", colorMiningRadar);
		redPhosphor = addItem("Red Phosphor", newItemI(3020, "redPhosphor", 21));
		greenPhosphor = addItem("Green Phosphor", newItemI(3021, "greenPhosphor", 13));
		bluePhosphor = addItem("Blue Phosphor", newItemI(3022, "bluePhosphor", 2));
		colorCRT = addItem("Colour CRT", newItemI(3023, "colorCRT", 8));
		colorMiningRadarCircuit = addItem("Colour Mining Radar Circuit", newItemI(3024, "colorMiningRadarCircuit", 10));
	}
	
	void addRecipes() {
		addShapelessRecipe(miningRadar, 1, new ItemStack(miningRadar, 1, -1), battery);
		addRecipe(mandrel, 1, "W", "W", "W", 'W', Block.planks);
		addShapelessRecipe(batteryCasing, 6, Item.ingotIron, mandrel);
		addRecipe(carbonRod, 6, "C", "C", "C", 'C', Item.coal);
		addShapelessRecipe(bowlAppleJuice, 1, Item.appleRed, Item.bowlEmpty);
		addShapelessRecipe(electrolytePaste, 6, bowlAppleJuice, new ItemStack(Item.dyePowder, 1, 15));
		addShapelessRecipe(battery, 1, batteryCasing, electrolytePaste, carbonRod);
		addSmeltingRecipe(carbonFilament, 1, Item.silk);
		addRecipe(cathodeRayTube, 1, "|gG", "|gf", "|gG",
			'|', Block.thinGlass, 'g', Item.lightStoneDust, 'G', Block.glass, 'f', carbonFilament);
		addRecipe(magnetron, 1, "rGr", "IGI", "rfr",
			'r', Item.redstone, 'G', Block.glass, 'I', Item.ingotIron, 'f', carbonFilament);
		addShapelessRecipe(fibreglassBoard, 1, Block.glass, Item.slimeBall);
		addRecipe(microwaveHorn, 1, "  I", "II ", "  I", 'I', Item.ingotIron);
		addRecipe(miningRadar, 1, "CMH", "LFB", "grg",
			'C', cathodeRayTube, 'M', magnetron, 'H', microwaveHorn, 'L', Block.lever, 'F', fibreglassBoard,
			'B', battery, 'g', Item.goldNugget, 'r', Item.redstone);
		addRecipe(slimophone, 1, "ltp", "grb", 'l', ledBarGraph, 't', triode, 'p', parabolicMicrophone,
			'g', Item.goldNugget, 'r', Item.redstone, 'b', battery);
		addRecipe(ledBarGraph, 1, "rgB", "rgB", "rgB",
			'r', Item.redstone, 'g', Item.lightStoneDust, 'B', new ItemStack(Block.cloth, 1, 15));
		addShapelessRecipe(slimophone, 1, new ItemStack(slimophone, 1, -1), battery);
		addRecipe(parabolicMicrophone, 1, " W", "Wp", " W", 'W', Block.planks, 'p', piezoTransducer);
		addRecipe(piezoTransducer, 1, "IqI", 'I', Item.ingotIron, 'q', quartzWafer);
		addSmeltingRecipe(quartzWafer, 1, Block.sandStone);
		addRecipe(triode, 1, " I ", "GrG", " f ", 
			'I', Item.ingotIron, 'G', Block.glass, 'r', Item.redstone, 'f', carbonFilament);
		addShapelessRecipe(redPhosphor, 1, Item.blazePowder, new ItemStack(Item.dyePowder, 1, 1));
		addShapelessRecipe(greenPhosphor, 1, Item.blazePowder, new ItemStack(Item.dyePowder, 1, 2));
		addShapelessRecipe(bluePhosphor, 1, Item.blazePowder, new ItemStack(Item.dyePowder, 1, 4));
		addRecipe(colorCRT, 1, "|rf", "|gf", "|bf",
			'|', Block.thinGlass, 'r', redPhosphor, 'g', greenPhosphor, 'b', bluePhosphor, 'f', carbonFilament);
		addRecipe(colorMiningRadarCircuit, 1, "rrr", " b ", " I ",
			'r', Item.redstone, 'b', fibreglassBoard, 'I', Item.ingotIron);
		addShapelessRecipe(colorMiningRadar, 1, miningRadar, colorCRT, colorMiningRadarCircuit);
		addRecipe(colorMiningRadar, 1, "CMH", "LFB", "grg",
			'C', colorCRT, 'M', magnetron, 'H', microwaveHorn, 'L', Block.lever, 'F', colorMiningRadarCircuit,
			'B', battery, 'g', Item.goldNugget, 'r', Item.redstone);
		addShapelessRecipe(colorMiningRadar, 1, new ItemStack(colorMiningRadar, 1, -1), battery);
	}
	
	private void addRecipe(Item product, int qty, Object... params) {
		GameRegistry.addRecipe(new ItemStack(product, qty), params);
	}
	
	private void addShapelessRecipe(Item product, int qty, Object... params) {
		GameRegistry.addShapelessRecipe(new ItemStack(product, qty), params);
	}
	
	private void addSmeltingRecipe(Item product, int qty, Item input) {
		GameRegistry.addSmelting(input.shiftedIndex, new ItemStack(product, qty), 0);
	}
	
	private  void addSmeltingRecipe(Item product, int qty, Block input) {
		GameRegistry.addSmelting(input.blockID, new ItemStack(product, qty), 0);
	}
	
	private Item newItem(int id, String name) {
		return new GregsItem(getItemID(id, name));
	}
	
	private Item newItemI(int id, String name, int icon) {
		return new GregsItem(getItemID(id, name)).setIconIndex(icon);
	}
	
	private Item newItemSI(int id, String name, int maxStack, int icon) {
		return new GregsItem(getItemID(id,name)).setMaxStackSize(maxStack).setIconIndex(icon);
	}
	
	private Item addItem(String name, Item item) {
		item.setItemName("gcewing." + idToName.get(item.shiftedIndex));
		LanguageRegistry.addName(item, name);
		return item;
	}

}
