package gcewing.prospecting;

import java.util.Properties;
import java.util.Vector;
import java.util.Enumeration;

public class OrderedProperties extends Properties {

	Vector<Object> order = new Vector<Object>();
	public boolean extended = false;

	public Object put(Object key, Object value) {
		if (!containsKey(key)) {
			order.add(key);
			extended = true;
		}
		return super.put(key, value);
	}
	
	public Enumeration<Object> keys() {
		return order.elements();
	}
	
	public int getInt(String name, int defaultValue) {
		int value;
		if (containsKey(name)) {
			String str = (String) get(name);
			value = Integer.parseInt(str);
		}
		else {
			put(name, Integer.toString(defaultValue));
			value = defaultValue;
		}
		return value;
	}

}
